×
INTELLIGENT WORK FORUMS
FOR ENGINEERING PROFESSIONALS

Contact US

Log In

Come Join Us!

Are you an
Engineering professional?
Join Eng-Tips Forums!
  • Talk With Other Members
  • Be Notified Of Responses
    To Your Posts
  • Keyword Search
  • One-Click Access To Your
    Favorite Forums
  • Automated Signatures
    On Your Posts
  • Best Of All, It's Free!

*Eng-Tips's functionality depends on members receiving e-mail. By joining you are opting in to receive e-mail.

Posting Guidelines

Promoting, selling, recruiting, coursework and thesis posting is forbidden.

Students Click Here

Generate Tractrix geometry in NX

Generate Tractrix geometry in NX

Generate Tractrix geometry in NX

(OP)
Hi,
I've been asked if NX can generate a geometry that's is a ''tractrix''. Ref this wikipedia page: https://en.wikipedia.org/wiki/Tractrix
The geometry is a variant of ''surface blend'' controlled by an expression. This one: x=t-\tanh(t),y=1/{\cosh(t) x=t-\tanh(t),y=1/{\cosh(t). ( from the Wikipedia page)
I'm running NX 12, but solution for newer versions is also possible.

Any suggestions?

Anders

RE: Generate Tractrix geometry in NX

I think that shape is/should be possible, at least as a curve.
the wikipedia page notes that a surface of revolution of this shape can be used as a loudspeaker.
Most surfaces are built from curves, The surface shape is a derivative of the curve shape-s.
are you looking to define a surface directly with this shape and skip the "curve stage" ?

Regards,
Tomas

Never try to teach a pig to sing. I wastes your time and it annoys the pig.smile

RE: Generate Tractrix geometry in NX

(OP)
If I could have NX to make a expression controlled 'Face blend' from the given expression, I would be happy.
No need for the curve, a 'Face blend' will do the trick.

Regards,
Anders

RE: Generate Tractrix geometry in NX

Hello,

I was used NX Journal for create spline sililar to tractrix.
Mayby it's usefull for You:
(You must change Rk and Rm)

CODE --> vb

Imports System
Imports NXOpen

Module Horn_trackix

    Sub Main(ByVal args() As String)



        Dim theSession As NXOpen.Session = NXOpen.Session.GetSession()
        Dim workPart As NXOpen.Part = theSession.Parts.Work
        Dim displayPart As NXOpen.Part = theSession.Parts.Display
        Dim lw As ListingWindow = theSession.ListingWindow
        lw.Open()
        Dim markId1 As NXOpen.Session.UndoMarkId = Nothing
        markId1 = theSession.SetUndoMark(NXOpen.Session.MarkVisibility.Visible, "Start")

        Dim nullNXOpen_NXObject As NXOpen.NXObject = Nothing
        Dim studioSplineBuilderEx1 As NXOpen.Features.StudioSplineBuilderEx = Nothing
        studioSplineBuilderEx1 = workPart.Features.CreateStudioSplineBuilderEx(nullNXOpen_NXObject)

        Dim origin1 As NXOpen.Point3d = New NXOpen.Point3d(0.0, 0.0, 0.0)
        Dim normal1 As NXOpen.Vector3d = New NXOpen.Vector3d(0.0, 0.0, 1.0)
        Dim plane1 As NXOpen.Plane = Nothing
        plane1 = workPart.Planes.CreatePlane(origin1, normal1, NXOpen.SmartObject.UpdateOption.WithinModeling)

        studioSplineBuilderEx1.DrawingPlane = plane1
        studioSplineBuilderEx1.OrientExpress.ReferenceOption = NXOpen.GeometricUtilities.OrientXpressBuilder.Reference.WcsDisplayPart
        studioSplineBuilderEx1.MovementMethod = NXOpen.Features.StudioSplineBuilderEx.MovementMethodType.View
        studioSplineBuilderEx1.OrientExpress.AxisOption = NXOpen.GeometricUtilities.OrientXpressBuilder.Axis.Passive
        studioSplineBuilderEx1.OrientExpress.PlaneOption = NXOpen.GeometricUtilities.OrientXpressBuilder.Plane.Passive
        studioSplineBuilderEx1.Extender.StartValue.RightHandSide = "0"
        studioSplineBuilderEx1.Extender.EndValue.RightHandSide = "0"
        studioSplineBuilderEx1.InputCurveOption = NXOpen.Features.StudioSplineBuilderEx.InputCurveOptions.Hide
        studioSplineBuilderEx1.MatchKnotsType = NXOpen.Features.StudioSplineBuilderEx.MatchKnotsTypes.None

        Dim Rm As Integer = 460 ' Mouth radius (mm*10) 'edit 2020.04.23
        Dim Rk As Integer = 75 ' Throat radius (mm*10) 'edit 2020.04.23

        For R As Integer = Rm To Rk Step -1

            Dim Rs As Double = Rm / 10
            Dim Rr As Double = R / 10
            Dim x As Double
            x = Rs * Math.Log((Rs + (Rs ^ 2 - Rr ^ 2) ^ 0.5) / Rr) - (Rs ^ 2 - Rr ^ 2) ^ 0.5

            'lw.WriteLine(x & ",   " & Rr)

            Dim coordinates1 As NXOpen.Point3d = New NXOpen.Point3d(0, Rr, x)
            Dim point1 As NXOpen.Point = Nothing
            point1 = workPart.Points.CreatePoint(coordinates1)
            Dim geometricConstraintData1 As NXOpen.Features.GeometricConstraintData = Nothing
            geometricConstraintData1 = studioSplineBuilderEx1.ConstraintManager.CreateGeometricConstraintData()
            geometricConstraintData1.Point = point1
            studioSplineBuilderEx1.ConstraintManager.Append(geometricConstraintData1)

        Next

        Dim nXObject1 As NXOpen.NXObject = Nothing
        nXObject1 = studioSplineBuilderEx1.Commit()
        studioSplineBuilderEx1.Destroy()


        theSession.DeleteUndoMark(markId1, Nothing)
    End Sub
End Module 

Best Regards

MANok
NX12
TC10

Red Flag This Post

Please let us know here why this post is inappropriate. Reasons such as off-topic, duplicates, flames, illegal, vulgar, or students posting their homework.

Red Flag Submitted

Thank you for helping keep Eng-Tips Forums free from inappropriate posts.
The Eng-Tips staff will check this out and take appropriate action.

Reply To This Thread

Posting in the Eng-Tips forums is a member-only feature.

Click Here to join Eng-Tips and talk with other members! Already a Member? Login


Resources

Low-Volume Rapid Injection Molding With 3D Printed Molds
Learn methods and guidelines for using stereolithography (SLA) 3D printed molds in the injection molding process to lower costs and lead time. Discover how this hybrid manufacturing process enables on-demand mold fabrication to quickly produce small batches of thermoplastic parts. Download Now
Design for Additive Manufacturing (DfAM)
Examine how the principles of DfAM upend many of the long-standing rules around manufacturability - allowing engineers and designers to place a part’s function at the center of their design considerations. Download Now
Taking Control of Engineering Documents
This ebook covers tips for creating and managing workflows, security best practices and protection of intellectual property, Cloud vs. on-premise software solutions, CAD file management, compliance, and more. Download Now

Close Box

Join Eng-Tips® Today!

Join your peers on the Internet's largest technical engineering professional community.
It's easy to join and it's free.

Here's Why Members Love Eng-Tips Forums:

Register now while it's still free!

Already a member? Close this window and log in.

Join Us             Close